class Properties():
    def __init__(self, file_name):
        self.properties_file_name = file_name
        self.properties={}

    def get_properties(self) -> dict:
        with open(self.properties_file_name, 'r', encoding="UTF-8") as pro_file:
            for line in pro_file.readlines():
                # 去掉两端的空格和\n符号
                line = line.strip().replace("\n", "")
                # 如果发现 # 符号，代表这一行或后边是注释内容
                if line.find("#") != -1:
                    line = line[0:line.find("#")]
                # 如果包含了等号，我们就要进行字典类型的转换处理
                if line.find("=") > 0:  # 这是我的注释
                    # 我们就用等号进行切分，形成新的字符串类型的list
                    strs = line.split("=")
                    # 获取字典
                    self.__get_dict(strs[0].strip(),self.properties,strs[1].strip())
        return self.properties

    def __get_dict(self, key_name, result_dict, value):
        # 检查key中是否包含. ，包含的话我们切分，不包含的话就直接设置值就可以了
        if (key_name.find(".") > 0):  # 这里用.进行了包含判断  www.greedyai.com
            k = key_name.split(".")[0] #用.进行切分，我拿第一个 www 作为一个key
            result_dict.setdefault(k, {}) # 把结果字典设置成 {www:{greedyai : {com: value}}
            return self.__get_dict(key_name[len(k) + 1:],result_dict[k],value)
        else:
            result_dict[key_name] = value
